//: INHERITT.CPP -- inheritance and templates
//. No error checking, full or empty checking; stripped-down
//. for the example.
//. Adapted from "Using C++" 2nd edition, Osborne/McGraw-Hill 1992
//. by Bruce Eckel
#include <iostream.h>
#include "ostring.h"

template<int sz> class stackb {
  void* s[sz];
  int i;
public:
  stackb() : i(0) {}
  void push(void* v) { s[i++] = v; }
  void* pop() { return s[--i]; }
};

template<class T, int sz>
class stack : public stackb<sz> {
public:
  void push(T* v) { stackb<sz>::push(v); }
  T* pop() { return (T*)stackb<sz>::pop(); }
};

void main() {
  stack<String, 2> SS;
  SS.push(new String("stack!"));
  SS.push(new String("Hello,"));
  for(int i = 0; i < 2; i++)
    cout << *SS.pop() << " ";
}


